Package ec.vector.breed

# Class ListCrossoverPipeline

java.lang.Object
ec.BreedingSource
ec.BreedingPipeline
ec.vector.breed.ListCrossoverPipeline

All Implemented Interfaces:
  `Prototype`, `Setup`, `SteadyStateBSourceForm`, `RandomChoiceChooserD`, `Serializable`, `Cloneable`

public class ListCrossoverPipeline extends BreedingPipeline
ListCrossoverPipeline is a crossover pipeline for vector individuals whose length may be lengthened or shortened. There are two crossover options available: one-point and two-point. One-point crossover picks a crossover point for each of the vectors (the crossover point can be different), and then does one-point crossover using those points. Two-point crossover picks TWO crossover points for each of the vectors (again, the points can be different among the vectors), and swaps the middle regions between the respective crossover points.

ListCrossoverPipeline will try tries times to meet certain constraints: first, the resulting children must be no smaller than min-child-size. Second, the amount of material removed from a parent must be no less than mix-crossover-percent and no more than max-crossover-percent.

If toss is true, then only one child is generated, else at most two are generated.

Typical Number of Individuals Produced Per `produce(...)` call
2 * minimum typical number of individuals produced by each source, unless toss is set, in which case it's simply the minimum typical number.

Number of Sources
2

Parameters

base.`toss` bool = `true` or `false` (default)/td> | (after crossing over with the first new individual, should its second sibling individual be thrown away instead of adding it to the population?)
base.`tries` int >= 1 | (number of times to try finding valid crossover points)
base.`min-child-size` int >= 0 (default) | (the minimum allowed size of a child)
base.`min-crossover-percent` 0 (default) <= double <= 1 | (the minimum percentage of an individual that may be removed during crossover)
base.`max-crossover-percent` 0 <= double <= 1 (default) | (the maximum percentage of an individual that may be removed during crossover)

Default Base
vector.list-xover

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `int`
  `crossoverType`
  `static final String`
  `KEY_PARENTS`
  `double`
  `maxCrossoverPercentage`
  `int`
  `minChildSize`
  `double`
  `minCrossoverPercentage`
  `static final int`
  `NUM_SOURCES`
  `int`
  `numTries`
  `static final String`
  `P_LIST_CROSSOVER`
  `static final String`
  `P_MAX_CROSSOVER_PERCENT`
  `static final String`
  `P_MIN_CHILD_SIZE`
  `static final String`
  `P_MIN_CROSSOVER_PERCENT`
  `static final String`
  `P_NUM_TRIES`
  `static final String`
  `P_TOSS`
  `protected ArrayList<Individual>`
  `parents`
  `boolean`
  `tossSecondParent`

  ### Fields inherited from class ec.BreedingPipeline

  `DYNAMIC_SOURCES, likelihood, mybase, P_LIKELIHOOD, P_NUMSOURCES, P_SOURCE, sources, V_SAME, V_STUB`

  ### Fields inherited from class ec.BreedingSource

  `NO_PROBABILITY, P_PROB, probability`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ListCrossoverPipeline()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  Creates a new individual cloned from a prototype, and suitable to begin use in its own evolutionary context.
  `Object`
  `computeValidationData(EvolutionState state, ArrayList<Individual> parents, int thread)`
  A hook called by ListCrossoverPipeline to allow subclasses to prepare for additional validation testing.
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `boolean`
  `isValidated(int[][] split, Object validationData)`
  A hook called by ListCrossoverPipeline to allow subclasses to further validate children crossover points.
  `int`
  `numSources()`
  Returns the number of sources to this pipeline.
  `int`
  `produce(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)`
  Produces n individuals from the given subpopulation and puts them into inds[start...start+n-1], where n = Min(Max(q,min),max), where q is the "typical" number of individuals the BreedingSource produces in one shot, and returns n.
  `void`
  `setup(EvolutionState state, Parameter base)`
  Sets up the BreedingPipeline.
  `int`
  `typicalIndsProduced()`
  Returns the "typical" number of individuals produced -- by default this is the minimum typical number of individuals produced by any children sources of the pipeline.

  ### Methods inherited from class ec.BreedingPipeline

  `fillStubs, finishProducing, individualReplaced, maxChildProduction, minChildProduction, preparePipeline, prepareToProduce, produces, sourcesAreProperForm`

  ### Methods inherited from class ec.BreedingSource

  `getProbability, pickRandom, setProbability, setupProbabilities`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_TOSS

    public static final String P_TOSS
    See Also:
      - Constant Field Values

  - ### P_LIST_CROSSOVER

    public static final String P_LIST_CROSSOVER
    See Also:
      - Constant Field Values

  - ### P_MIN_CHILD_SIZE

    public static final String P_MIN_CHILD_SIZE
    See Also:
      - Constant Field Values

  - ### P_NUM_TRIES

    public static final String P_NUM_TRIES
    See Also:
      - Constant Field Values

  - ### P_MIN_CROSSOVER_PERCENT

    public static final String P_MIN_CROSSOVER_PERCENT
    See Also:
      - Constant Field Values

  - ### P_MAX_CROSSOVER_PERCENT

    public static final String P_MAX_CROSSOVER_PERCENT
    See Also:
      - Constant Field Values

  - ### NUM_SOURCES

    public static final int NUM_SOURCES
    See Also:
      - Constant Field Values

  - ### KEY_PARENTS

    public static final String KEY_PARENTS
    See Also:
      - Constant Field Values

  - ### tossSecondParent

    public boolean tossSecondParent

  - ### crossoverType

    public int crossoverType

  - ### minChildSize

    public int minChildSize

  - ### numTries

    public int numTries

  - ### minCrossoverPercentage

    public double minCrossoverPercentage

  - ### maxCrossoverPercentage

    public double maxCrossoverPercentage

  - ### parents

    protected ArrayList<Individual> parents

- ## Constructor Details

  - ### ListCrossoverPipeline

    public ListCrossoverPipeline()

- ## Method Details

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).

  - ### numSources

    public int numSources()
    Description copied from class: `BreedingPipeline`
    Returns the number of sources to this pipeline. Called during BreedingPipeline's setup. Be sure to return a value > 0, or DYNAMIC_SOURCES which indicates that setup should check the parameter file for the parameter "num-sources" to make its determination.
    Specified by:
      `numSources` in class `BreedingPipeline`

  - ### clone

    public Object clone()
    Description copied from interface: `Prototype`
    Creates a new individual cloned from a prototype, and suitable to begin use in its own evolutionary context.

    Typically this should be a full "deep" clone. However, you may share certain elements with other objects rather than clone hem, depending on the situation:

    - If you hold objects which are shared with other instances, don't clone them.
    - If you hold objects which must be unique, clone them.
    - If you hold objects which were given to you as a gesture of kindness, and aren't owned by you, you probably shouldn't clone them.
    - DON'T attempt to clone: Singletons, Cliques, or Populations, or Subpopulation.
    - Arrays are not cloned automatically; you may need to clone an array if you're not sharing it with other instances. Arrays have the nice feature of being copyable by calling clone() on them.

    Implementations.

    - If no ancestor of yours implements clone(), and you have no need to do clone deeply, and you are abstract, then you should not declare clone().
    - If no ancestor of yours implements clone(), and you have no need to do clone deeply, and you are not abstract, then you should implement it as follows:

      ``

           public Object clone()
               {
               try
                   {
                   return super.clone();
                   }
               catch ((CloneNotSupportedException e)
                   { throw new InternalError(); } // never happens
               }

    - If no ancestor of yours implements clone(), but you need to deep-clone some things, then you should implement it as follows:

      ``

           public Object clone()
               {
               try
                   {
                   MyObject myobj = (MyObject) (super.clone());

                   // put your deep-cloning code here...
                   }
               catch ((CloneNotSupportedException e)
                   { throw new InternalError(); } // never happens
               return myobj;
               }

    - If an ancestor has implemented clone(), and you also need to deep clone some things, then you should implement it as follows:

      ``

           public Object clone()
               {
               MyObject myobj = (MyObject) (super.clone());

               // put your deep-cloning code here...

               return myobj;
               }

    Specified by:
      `clone` in interface `Prototype`
    Overrides:
      `clone` in class `BreedingPipeline`

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Description copied from class: `BreedingSource`
    Sets up the BreedingPipeline. You can use state.output.error here because the top-level caller promises to call exitIfErrors() after calling setup. Note that probability might get modified again by an external source if it doesn't normalize right.

    The most common modification is to normalize it with some other set of probabilities, then set all of them up in increasing summation; this allows the use of the fast static BreedingSource-picking utility method, BreedingSource.pickRandom(...). In order to use this method, for example, if four breeding source probabilities are {0.3, 0.2, 0.1, 0.4}, then they should get normalized and summed by the outside owners as: {0.3, 0.5, 0.6, 1.0}.

    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`
    Overrides:
      `setup` in class `BreedingPipeline`
    See Also:
      - `Prototype.setup(EvolutionState,Parameter)`

  - ### typicalIndsProduced

    public int typicalIndsProduced()
    Description copied from class: `BreedingPipeline`
    Returns the "typical" number of individuals produced -- by default this is the minimum typical number of individuals produced by any children sources of the pipeline. If you'd prefer something different, override this method.
    Overrides:
      `typicalIndsProduced` in class `BreedingPipeline`

  - ### produce

    public int produce(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)
    Description copied from class: `BreedingSource`
    Produces n individuals from the given subpopulation and puts them into inds[start...start+n-1], where n = Min(Max(q,min),max), where q is the "typical" number of individuals the BreedingSource produces in one shot, and returns n. max must be >= min, and min must be >= 1. For example, crossover might typically produce two individuals, tournament selection might typically produce a single individual, etc.
    Specified by:
      `produce` in class `BreedingSource`

  - ### computeValidationData

    public Object computeValidationData(EvolutionState state, ArrayList<Individual> parents, int thread)
    A hook called by ListCrossoverPipeline to allow subclasses to prepare for additional validation testing. Primarily used by GECrossoverPipeline.

  - ### isValidated

    public boolean isValidated(int[][] split, Object validationData)
    A hook called by ListCrossoverPipeline to allow subclasses to further validate children crossover points. Primarily used by GECrossoverPipeline.